package com.huiju.estateagents.statistic.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.huiju.estateagents.base.ResponseBean;
import com.huiju.estateagents.excel.ActivityStatistics.*;
import com.huiju.estateagents.statistic.mapper.TaActicityStaticMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.LocalTime;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class TaActivityStaticServiceImpl {
    @Autowired
    private TaActicityStaticMapper taActicityStaticMapper;

    public ResponseBean activityStatistical(LocalDate startDate, LocalDate endDate, String buidling, String targetType, Integer orgId){

        ResponseBean responseBean = new ResponseBean();
        Map<String, Object> map = new HashMap<>();

        Integer sharePersonNum = taActicityStaticMapper.selectSharePersonNum(startDate, endDate, buidling, targetType, orgId);

        Integer shareNum = taActicityStaticMapper.selectShareNum(startDate, endDate, buidling, targetType, orgId);

        Integer visitPersonNum = taActicityStaticMapper.selectVisitPersonNum(startDate, endDate, buidling, targetType, orgId);

        Integer visitNum = taActicityStaticMapper.selectVisitNum(startDate, endDate, buidling, targetType, orgId);

        map.put("sharePersonNum", sharePersonNum);
        map.put("shareNum", shareNum);
        map.put("visitPersonNum", visitPersonNum);
        map.put("visitNum", visitNum);

        responseBean.addSuccess(map);

        return responseBean;
    }

    public ResponseBean selectAllActivityUser(Integer orgId, LocalDate startDate, LocalDate endDate, String buildingId, String targetType){
        ResponseBean responseBean = new ResponseBean();

        // 新增用户数
        List<Map<String, Object>> selectShareCount = taActicityStaticMapper.selectShareCount(orgId, startDate, endDate, buildingId, targetType);
        List<Map<String, Object>> selectSharePersonCount = taActicityStaticMapper.selectSharePersonCount(orgId, startDate, endDate, buildingId, targetType);
        List<Map<String, Object>> selectVisitCount = taActicityStaticMapper.selectVisitCount(orgId, startDate, endDate, buildingId, targetType);
        List<Map<String, Object>> selectVisitPersonCount = taActicityStaticMapper.selectVisitPersonCount(orgId, startDate, endDate, buildingId, targetType);
        List<Map<String, Object>> selectAddRegistCount = taActicityStaticMapper.selectAddRegistCount(orgId, startDate, endDate, buildingId, targetType);


        for (Map<String, Object> ssc : selectShareCount){
            //如果时间相等，那么原来子查询的数据塞到统一的数据处理map中
            for (Map<String, Object> sspc : selectSharePersonCount){
                if (sspc.get("date").equals(ssc.get("date"))){
                    ssc.put("sharePersonCount", sspc.get("sharePersonCount"));
                }
                continue;
            }
            for (Map<String, Object> svc : selectVisitCount){
                if (svc.get("date").equals(ssc.get("date"))){
                    ssc.put("visitCount", svc.get("visitCount"));
                }
                continue;
            }
            for (Map<String, Object> svpc : selectVisitPersonCount){
                if (svpc.get("date").equals(ssc.get("date"))){
                    ssc.put("visitPersonCount", svpc.get("visitPersonCount"));
                }
                continue;
            }
            for (Map<String, Object> sarc : selectAddRegistCount){
                if (sarc.get("date").equals(ssc.get("date"))){
                    ssc.put("addregistCount", sarc.get("addregistCount"));
                }
                continue;
            }
        }

        Map<String, Object> map = new HashMap<>();
        map.put("selectAllActivityUser", selectShareCount);
        responseBean.addSuccess(map);
        return responseBean;
    }

    public ResponseBean selectTableData(Integer pageNum, Integer pageSize, Integer orgId, LocalDate startDate, LocalDate endDate, String buildingId, String targetType, String sort, String colKey){
        IPage<StatisicAttractUser> iPage = new Page<>(pageNum, pageSize);
        String sortType = "ascend".equals(sort) ? "asc" : "desc";
        IPage<StatisicAttractUser> data = taActicityStaticMapper.selectTableData(iPage, orgId, startDate, endDate, buildingId, targetType, sortType, colKey);
        return ResponseBean.success(data);
    }

    public List<StatisicAttractUser> selectExportTableData(Integer orgId, LocalDate startDate, LocalDate endDate, String buildingId, String targetType, String sort, String colKey){
        String sortType = "ascend".equals(sort) ? "asc" : "desc";
        return taActicityStaticMapper.selectExportTableData(orgId, startDate, endDate, buildingId, targetType, sortType, colKey);
    }

    public ResponseBean selectActivityStatisDetail(Integer pageNum, Integer pageSize, Integer orgId, LocalDate startDate, LocalDate endDate, String buildingId, String targetType, String activityName, String sort, String colKey){
        IPage<ActivityDetailShareRecord> iPage = new Page<>(pageNum, pageSize);
        String sortType = "ascend".equals(sort) ? "asc" : "desc";
        IPage<ActivityDetailShareRecord> data = taActicityStaticMapper.selectActivityStatisDetail(iPage, orgId, startDate, endDate, buildingId, targetType, activityName, sortType, colKey);
        return ResponseBean.success(data);
    }

    public List<ActivityDetailShareRecord> selectActivityStatisDetailExport(Integer orgId, LocalDate startDate, LocalDate endDate, String buildingId, String targetType, String activityName, String sort, String colKey){
        String sortType = "ascend".equals(sort) ? "asc" : "desc";
        return taActicityStaticMapper.selectActivityStatisDetailExport(orgId, startDate, endDate, buildingId, targetType, activityName, sortType, colKey);
    }

    public ResponseBean selectActivitySharePersonNum(Integer pageNum, Integer pageSize, Integer orgId, LocalDate startDate, LocalDate endDate, String sharePersonType, String sharePersonName, String sharePhone, String sort, String colKey){
        IPage<SharePersonNum> iPage = new Page<>(pageNum, pageSize);
        String sortType = "ascend".equals(sort) ? "asc" : "desc";

        IPage<SharePersonNum> data = taActicityStaticMapper.selectActivitySharePersonNum(iPage, orgId, LocalDateTime.of(startDate, LocalTime.MAX), LocalDateTime.of(endDate, LocalTime.MAX), sharePersonType, sharePersonName, sharePhone, sortType, colKey);
        return ResponseBean.success(data);
    }

    public List<SharePersonNum> selectActivitySharePersonNumExport(Integer orgId, LocalDate startDate, LocalDate endDate, String sharePersonType, String sharePersonName, String sharePhone, String sort, String colKey){
        String sortType = "ascend".equals(sort) ? "asc" : "desc";
        return taActicityStaticMapper.selectActivitySharePersonNumExport(orgId, LocalDateTime.of(startDate, LocalTime.MAX), LocalDateTime.of(endDate, LocalTime.MAX), sharePersonType, sharePersonName, sharePhone, sortType, colKey);
    }

    public ResponseBean selectActivityShareNum(Integer pageNum, Integer pageSize, Integer orgId, LocalDate startDate, LocalDate endDate, String sharePersonType, String sharePersonName, String sharePhone, String sort, String colKey){
        IPage<ShareNum> iPage = new Page<>(pageNum, pageSize);
        String sortType = "ascend".equals(sort) ? "asc" : "desc";

        IPage<ShareNum> data = taActicityStaticMapper.selectActivityShareNum(iPage, orgId, LocalDateTime.of(startDate, LocalTime.MAX), LocalDateTime.of(endDate, LocalTime.MAX), sharePersonType, sharePersonName, sharePhone, sortType, colKey);
        return ResponseBean.success(data);
    }

    public List<ShareNum> selectActivityShareNumExport(Integer orgId, LocalDate startDate, LocalDate endDate, String sharePersonType, String sharePersonName, String sharePhone, String sort, String colKey){
        String sortType = "ascend".equals(sort) ? "asc" : "desc";
        return taActicityStaticMapper.selectActivityShareNumExport( orgId, LocalDateTime.of(startDate, LocalTime.MAX), LocalDateTime.of(endDate, LocalTime.MAX), sharePersonType, sharePersonName, sharePhone, sortType, colKey);
    }

    public ResponseBean selectActivityAddRegistNum(Integer pageNum, Integer pageSize, Integer orgId, LocalDate startDate, LocalDate endDate, String personFrom){
        IPage<AddRegistNum> iPage = new Page<>(pageNum, pageSize);
        IPage<AddRegistNum> data = taActicityStaticMapper.selectActivityAddRegistNum(iPage, orgId, LocalDateTime.of(startDate, LocalTime.MAX), LocalDateTime.of(endDate, LocalTime.MAX), personFrom);
        return ResponseBean.success(data);
    }

    public List<AddRegistNum> selectActivityAddRegistNumExport(Integer orgId, LocalDate startDate, LocalDate endDate, String personFrom){
        return taActicityStaticMapper.selectActivityAddRegistNumExport(orgId, LocalDateTime.of(startDate, LocalTime.MAX), LocalDateTime.of(endDate, LocalTime.MAX), personFrom);
    }

    public ResponseBean selectActivityVisitNum(Integer pageNum, Integer pageSize, Integer orgId, LocalDate startDate, LocalDate endDate, String personFrom, String provice, String realtyConsultant, String realtyConsultantPhone){
        IPage<VisitNum> iPage = new Page<>(pageNum, pageSize);
        IPage<VisitNum> data = taActicityStaticMapper.selectActivityVisitNum(iPage, orgId, LocalDateTime.of(startDate, LocalTime.MAX), LocalDateTime.of(endDate, LocalTime.MAX), personFrom, provice, realtyConsultant, realtyConsultantPhone);
        return ResponseBean.success(data);
    }
}
